<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22">
            <span>退货原因设置信息列表</span>
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:returnReason:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>
      <el-table v-loading="loading" border :data="returnReasonList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="returnReasonCode" />
        <el-table-column label="退货原因" align="center" prop="returnReasonName" />
        <el-table-column label="是否显示" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <!-- <el-table-column label="数据来源" align="center" prop="dataSource" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:returnReason:edit']">编辑</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改退货原因对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="returnReasonFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="原因" prop="returnReasonName">
          <el-input v-model="form.returnReasonName" placeholder="请输入退货原因" />
        </el-form-item>
        <el-form-item label="是否显示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio v-for="dict in sys_platform_yes_no" :key="dict.value" :value="dict.value">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ReturnReason" lang="ts">
import { listReturnReason, getReturnReason, delReturnReason, addReturnReason, updateReturnReason, changeStatus } from '@/api/order/returnReason';
import { ReturnReasonVO, ReturnReasonQuery, ReturnReasonForm } from '@/api/order/returnReason/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));
const returnReasonList = ref<ReturnReasonVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const returnReasonFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: ReturnReasonForm = {
  id: undefined,
  returnReasonCode: undefined,
  returnReasonName: undefined,
  isShow: '0',
  dataSource: undefined,
  status: undefined,
  remark: undefined
};
const data = reactive<PageData<ReturnReasonForm, ReturnReasonQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    returnReasonCode: undefined,
    returnReasonName: undefined,
    isShow: undefined,
    dataSource: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    returnReasonName: [{ required: true, message: '退货原因不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询退货原因列表 */
const getList = async () => {
  loading.value = true;
  const res = await listReturnReason(queryParams.value);
  returnReasonList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  returnReasonFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

const handleStatusChange = async (row: ReturnReasonVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: ReturnReasonVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加退货原因';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: ReturnReasonVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getReturnReason(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改退货原因';
};

/** 提交按钮 */
const submitForm = () => {
  returnReasonFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateReturnReason(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addReturnReason(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: ReturnReasonVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除退货原因编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delReturnReason(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/returnReason/export',
    {
      ...queryParams.value
    },
    `returnReason_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
